package com.ruoyi.system.controller;


import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.wages.dao.PowerAllDAO;
import com.ruoyi.system.model.wages.dao.PowerDAO;
import com.ruoyi.system.model.wages.dao.PowerWagesComparation;
import com.ruoyi.system.model.wages.dao.PowerWagesDetails;
import com.ruoyi.system.model.wages.vo.PowerVo;
import com.ruoyi.system.service.PowerWagesService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import java.util.Map;

/**
 * @author haiwe
 * @date 2024/6/26
 */
@RestController
@RequestMapping("/power")
@RequiredArgsConstructor
public class PowerWagesController {
    private final PowerWagesService powerWagesService;

    /**
     * 返回前端所需要的数据
     * @param mineId
     * @param date
     * @return 前端所需要的数据
     */
    @GetMapping
    public AjaxResult list(@RequestParam("mineId") String mineId,
                           @RequestParam("date") String date)  {
        List<PowerVo> data = powerWagesService.selectByMineIdAndDate(mineId,date);
        return AjaxResult.success(data);
    }


    @PostMapping("/all")
    public AjaxResult save(@RequestParam("file") MultipartFile file,
                           @RequestPart PowerDAO powerDAO,
                           @RequestPart PowerAllDAO powerAllDAO

    ){
        //1、处理表格
        String date = powerDAO.getImportTime();
        String mineId = powerDAO.getMineId();
        Boolean cAnalyzed = powerWagesService.readCExcel(file,date,mineId);
        if (!cAnalyzed) {
            return AjaxResult.error("解析失败");
        }
        Boolean dAnalyzed =  powerWagesService.readDExcel(file,date,mineId);
        if (!dAnalyzed) {
            return AjaxResult.error("解析失败");
        }
        //2、处理特殊表的表头
        Boolean added = powerWagesService.add(powerDAO);
        if (!added) {
            return AjaxResult.error("对照处理失败");
        }
        //3、处理特殊表的数据
        Boolean pAdd = powerWagesService.pAdd(powerAllDAO);
        if (!pAdd) {
            return AjaxResult.error("数据处理失败");
        }
        return AjaxResult.success();
    }

}
